#################################################################################
# CADO4MI - CADO4MI: Computer Assisted Design of Oligonucleotide For MIcroarray #
#                                                                               #
# CADO4MI is a program to design oligonucleotide for microarrays or PCR.        #
#                                                                               #
# Copyright (C) 2006 Jean Muller (jean.muller@igbmc.u-strasbg.fr)               # 
#                                                                               #
# Please cite the following article:                                            #
#    Muller J et al                                                             #
#    Design and evaluation of Actichip,                                         #
#    a thematic microarray for the study of the actin cytoskeleton.             #
#    BMC Genomics 2007 Aug 29;8(1):294.                                         #
#                                                                               #
# This is part of CADO4MI source code.                                          #
#                                                                               #
# This program is free software; you can redistribute it and/or                 #
# modify it under the terms of the GNU General Public License                   # 
# as published by the Free Software Foundation; either version 2                # 
# of the License, or (at your option) any later version.                        #
#                                                                               #
# This program is distributed in the hope that it will be useful,               # 
# but WITHOUT ANY WARRANTY; without even the implied warranty of                #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                 #
# GNU General Public License for more details.                                  #
#                                                                               #
# You should have received a copy of the GNU General Public License             #
# along with this program; if not, write to the Free Software                   #
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                     #
#################################################################################

###########################################
#                                         #
#  ActiChip                               #
#                                         #
#  WebPage http://www.microarrays.lu/     #
#                                         #
###########################################

proc ActiChip1_0 {} {
   
    Wup "Permet de rendre la liste des PAB des oligos commandes pour ActiChip1_0"

    set Fichier "[file join [RepertoireDuGenome] fiches ActiChip1_0.txt]"

    global Oligo_ActiChip1_0

    if {[info exists Oligo_ActiChip1_0]} {
	return $Oligo_ActiChip1_0
    }

    if {! [file exists $Fichier]} {return ""}

    set Oligo_ActiChip1_0 ""

    set F [open "$Fichier"]
    while {[gets $F Ligne]>=0} {
	if {! [regexp -nocase {[a-z0-9]+} $Ligne]} {continue}
	set  PAB ""
	scan $Ligne "%s" PAB
	lappend Oligo_ActiChip1_0 $PAB
    }
    close $F

    set     Oligo_ActiChip1_0 [lsort -unique $Oligo_ActiChip1_0]
    return $Oligo_ActiChip1_0
}

proc ActiChip2_0 {} {
   
    Wup "Permet de rendre la liste des PAB des oligos commandes pour ActiChip2_0"

    set Fichier "[file join [RepertoireDuGenome] fiches ActiChip2_1.txt]"

    global Oligo_ActiChip2_0

    if {[info exists Oligo_ActiChip2_0]} {
	return $Oligo_ActiChip2_0
    }

    if {! [file exists $Fichier]} {return ""}

    set Oligo_ActiChip2_0 ""

    set F [open "$Fichier"]
    while {[gets $F Ligne]>=0} {
	if {! [regexp -nocase {[a-z0-9]+} $Ligne]} {continue}
	set  PAB ""
	scan $Ligne "%s" PAB
	lappend Oligo_ActiChip2_0 $PAB
    }
    close $F

    set     Oligo_ActiChip2_0 [lsort -unique $Oligo_ActiChip2_0]
    return $Oligo_ActiChip2_0
}

proc ActiChip3_0 {} {
   
    Wup "Permet de rendre la liste des PAB des oligos commandes pour ActiChip3_0"

    set Fichier "[file join [RepertoireDuGenome] fiches ActiChip3_0.txt]"

    global Oligo_ActiChip3_0

    if {[info exists Oligo_ActiChip3_0]} {
	return $Oligo_ActiChip3_0
    }

    if {! [file exists $Fichier]} {return ""}

    set Oligo_ActiChip3_0 ""

    set F [open "$Fichier"]
    while {[gets $F Ligne]>=0} {
	if {! [regexp -nocase {[a-z0-9]+} $Ligne]} {continue}
	set  PAB ""
	scan $Ligne "%s" PAB
	lappend Oligo_ActiChip3_0 $PAB
    }
    close $F

    set     Oligo_ActiChip3_0 [lsort -unique $Oligo_ActiChip3_0]
    return $Oligo_ActiChip3_0
}

