#################################################################################
# CADO4MI - CADO4MI: Computer Assisted Design of Oligonucleotide For MIcroarray #
#                                                                               #
# CADO4MI is a program to design oligonucleotide for microarrays or PCR.        #
#                                                                               #
# Copyright (C) 2006 Jean Muller (jean.muller@igbmc.u-strasbg.fr)               # 
#                                                                               #
# Please cite the following article:                                            #
#    Muller J et al                                                             #
#    Design and evaluation of Actichip,                                         #
#    a thematic microarray for the study of the actin cytoskeleton.             #
#    BMC Genomics 2007 Aug 29;8(1):294.                                         #
#                                                                               #
# This is part of CADO4MI source code.                                          #
#                                                                               #
# This program is free software; you can redistribute it and/or                 #
# modify it under the terms of the GNU General Public License                   # 
# as published by the Free Software Foundation; either version 2                # 
# of the License, or (at your option) any later version.                        #
#                                                                               #
# This program is distributed in the hope that it will be useful,               # 
# but WITHOUT ANY WARRANTY; without even the implied warranty of                #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the                 #
# GNU General Public License for more details.                                  #
#                                                                               #
# You should have received a copy of the GNU General Public License             #
# along with this program; if not, write to the Free Software                   #
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                     #
#################################################################################

proc AfficheVariable {Page {Maniere ""} {NomDuFichierOrigine ""}} {

    Wup "Shows the text Page in a listbox, with a lot of buttons."
    
    Gs "Frame"

    if {$Page==""} {return ""}
    
    global VariableDeRetour
    #global LesFenetresDePAB
    global PagePropre
    #global CurrentGenome
    
    set Nom ""
    set Queue [file tail $NomDuFichierOrigine]
    set Nom "$Queue"

    set w [NomDe fenetre]
    regsub -all {\t} $Page "        " PagePropre($w)

    #lappend LesFenetresDePAB($Queue) $w
    
    if {   $NomDuFichierOrigine == "" } {
        set NomDuFichierOrigine "Tsointsoin"
    }
    set Titre "$NomDuFichierOrigine"

    if {$Maniere=="AutoManiere" || $Maniere==""} {
        set Maniere [LaManierePourAffiche $NomDuFichierOrigine]
    }

    toplevel    $w
    wm title    $w "$Titre"
    wm iconname $w "$Titre"
    wm protocol $w WM_DELETE_WINDOW "unset PagePropre($w) ; after 10 destroy $w ; FermeFenetre"

    label $w.msg -wraplength 4i -justify left -text "$Titre"
    pack  $w.msg -side top

    set    Clavier $w.buttons
    frame $Clavier
    pack  $Clavier -side bottom -fill x -padx 3m -pady 1m

    TouchePour $Clavier NouvelleGamme
    TouchePour $Clavier NouvelleCouleur "red"
    #TouchePour $Clavier "Dismiss"       "unset PagePropre($w) ; after 10 destroy $w ; FermeFenetre"
    TouchePour $Clavier "Dismiss"       "eval \[wm protocol $w WM_DELETE_WINDOW\]"

    TouchePour $Clavier NouvelleCouleur "grey"
    set A [TouchePour $Clavier "Save all" "SaveAs        \[set PagePropre($w)\]"]
    TouchePour <2>                "/sel." "catch {SaveAs \[selection get\]}"
    TouchePour <3>                "/Edit" "EditAndShow   \[set PagePropre($w)\]"
    set Texte [format   "%-10s" "Allow to save all or selected lines, and also edit lines"]
    set_balloon $A "$Texte"

    TouchePour $Clavier NouvelleGamme
    TouchePour $Clavier NouvelleCouleur "yellow"
    set B [TouchePour $Clavier "Next" "Focalise $w"]
    TouchePour <2>             "/Top" "Focalise $w top" 
    TouchePour <3>             "/New" "Focalise $w ask"
    set    Texte [format   "%-10s" "Allow to search and highlight words in lines"]
    append Texte [format "\n%-10s" "New for new word(s), Next for next matching line and top for the first"]
    set_balloon $B "$Texte"

    set J [TouchePour $Clavier "Split in words" "catch {OffreLesMots \[selection get\]}"]
    #set J [TouchePour $Clavier "Split in words" "OffreLesMots \[selection get\]"]
    set Texte [format   "%-10s" "Split selected line(s) into separate words"]
    set_balloon $J "$Texte"

    #set C [TouchePour $Clavier "Highlight $Nom" "Illumine $Nom $w"]
    #set Texte [format   "%-10s" "Highlight line"]
    #set_balloon $C "$Texte"
    
    TouchePour $Clavier NouvelleGamme
    if {[regexp "AvecBlaste" $Maniere] || [regexp "AvecFormate" $Maniere]} {
        TouchePour $Clavier NouvelleCouleur "green"
        set D [TouchePour $Clavier "Run BLAST"  "Blaste Choix \[set PagePropre($w)\]"]
        #set D [TouchePour $Clavier "Run BlastP" "Blaste P     \[set PagePropre($w)\]"]
        #TouchePour <2>      "/tN"               "Blaste tN    \[set PagePropre($w)\]"
        #TouchePour <3>      "/Choose"           "Blaste Choix \[set PagePropre($w)\]"
	set Texte [format   "%-10s" "Allow to launch BLAST"]
	set_balloon $D "$Texte"

        TouchePour $Clavier NouvelleCouleur "green"
        set E [TouchePour $Clavier "Change format" "AfficheVariable \[FormateSequence \[set PagePropre($w)\]\] AvecFormateAvecBlasteSansFetch"]
        #set E [TouchePour $Clavier "Change format" "AfficheVariable \[FormateSequence \[set PagePropre($w)\]\] AvecFormateAvecBlasteSansFetch \[file tail $NomDuFichierOrigine\]"]
        #TouchePour <2> "/sel." "AfficheVariable \[FormateSequence \[selection get\]\] AvecFormateAvecBlasteSansFetch part_of_[file tail $NomDuFichierOrigine]"
	set Texte [format   "%-10s" "Allow to change sequence format"]
	set_balloon $E "$Texte"
    }

    if {[regexp "AvecShow" $Maniere]} {
        set F [TouchePour $Clavier "Show file" "AfficheLesFichiers \[selection get\] AutoManiereAvecShow"]
        #TouchePour <2>     "/File" "AfficheLesFichiers  \[selection get\] AutoManiereAvecShow"
        #TouchePour <2>     "/File" "AfficheLesFichiersApresSplit  \[selection get\] AutoManiereAvecShow"
        #TouchePour <3>    "/Split" "OffreLesMots  \[selection get\]"
	set    Texte [format   "%-10s" "If words corresponds to an existing file allow to display it"]
	#append Texte [format "\n%-10s" "Display .log or .oligo file"]
	#append Texte [format "\n%-10s" "Check best hit in database, Self-complementarity"]
	set_balloon $F "$Texte"
    }
        
    if {[regexp "AvecRetour" $Maniere]} {
        TouchePour $Clavier "Validate sel." "set VariableDeRetour($w) \[selection get\]"      "" "green"
        TouchePour <2>               "/All" "set VariableDeRetour($w) \[set PagePropre($w)\]" ""
        TouchePour <3>               "/NO!" "set VariableDeRetour($w) {}"
    }
    if {[regexp "AvecSegAlignement" $Maniere]} {
        TouchePour $Clavier NouvelleGamme
        TouchePour $Clavier NouvelleCouleur "lightblue"
        set G [TouchePour $Clavier "BLAST alignement" "catch {AfficheLesAliEnPage \[set PagePropre($w)\] \[selection get\] $NomDuFichierOrigine}"]
	set Texte [format   "%-10s" "Allow to show blast alignment"]
	set_balloon $G "$Texte"

        set H [TouchePour $Clavier "BLAST View" "DrawBlast $NomDuFichierOrigine"]
        #set H [TouchePour $Clavier "View 1" "IllustreLeBlast $NomDuFichierOrigine"]
        #TouchePour <2> "/ View 2" "DrawBlast $NomDuFichierOrigine"
        #TouchePour <2> "/Map"  "AfficheMapping $NomDuFichierOrigine \[selection get\]"
        #TouchePour <3> "/View 2" "DrawBlast $NomDuFichierOrigine"
	set    Texte [format   "%-10s" "View: Draw blast output"]
	#append Texte [format "\n%-10s" "Mapping: Draw selected alignment"]
	#append Texte [format "\n%-10s" "View 2: Draw blast output (2 panels)"]
	set_balloon $H "$Texte"
    }
    
    if {! [regexp "SansFetch" $Maniere]} {
        TouchePour $Clavier NouvelleGamme
        TouchePour $Clavier NouvelleCouleur "orange"
        #set FichierAussi ""
        #if {0&&[OnTraiteUneCollection]} { set FichierAussi "$NomDuFichierOrigine" }
        #if {0&&[OnTraiteDesCDNAs]}      { set FichierAussi "OnVeutNucEMBL" } 
        
        #set I [TouchePour $Clavier "Fetch" "AfficheFetch  \[selection get\] $FichierAussi"]
        #TouchePour <2>           "/nature" "AfficheFetch  \[selection get\] OnVeutNature"
        #TouchePour <3>              "/seq" "AfficheFetch  \[selection get\] $NomDuFichierOrigine"
	#set Texte [format   "%-10s" "Retrieve sequence information from databases"]
	#set_balloon $I "$Texte"

        #set J [TouchePour $Clavier "Split in words" "OffreLesMots  \[selection get\]"]
	#set Texte [format   "%-10s" "Split selected line(s) into separate words"]
	#set_balloon $J "$Texte"
    }
    frame $w.frame -borderwidth 10
    pack  $w.frame -side top -expand yes -fill both
        
    scrollbar $w.frame.yscroll -command "$w.frame.list yview"
    scrollbar $w.frame.xscroll -command "$w.frame.list xview" -orient horizontal 
    set Largeur 80
    set Hauteur 35
    if {[regexp "GrandeLargeur" $Maniere]} {set Largeur 128}
    
    listbox $w.frame.list \
	    -width            $Largeur \
	    -height           $Hauteur \
	    -setgrid          1 \
	    -yscroll          "$w.frame.yscroll set" \
	    -xscroll          "$w.frame.xscroll set" \
	    -selectmode       extended \
	    -background       "LightGrey" \
	    -foreground       "Black" \
	    -selectbackground "LightYellow" \
	    -selectforeground "Black" \
	    -font [list Courier [PolicePourListBox]]
    
    grid $w.frame.list    -row 0 -column 0 -rowspan 1 -columnspan 1 -sticky nsew
    grid $w.frame.yscroll -row 0 -column 1 -rowspan 1 -columnspan 1 -sticky nsew
    grid $w.frame.xscroll -row 1 -column 0 -rowspan 1 -columnspan 1 -sticky nsew
    grid rowconfig    $w.frame 0 -weight 1 -minsize 0
    grid columnconfig $w.frame 0 -weight 1 -minsize 0
    
    set nLignes 0
    foreach Ligne [split [set PagePropre($w)] "\n"] {
        incr nLignes
        if { [regexp "AvecSegAlignement" $Maniere] && [regexp {^>[\./a-zA-Z]} $Ligne]} { break }
        $w.frame.list insert end $Ligne
    }

    if {$nLignes<30} {$w.frame.list configure -height [expr {$nLignes+3}]}

    if {[regexp "AvecEtude" $Maniere] && $Nom!=""} {Illumine $Nom $w}

    #bind $w.frame.list <3>               "DecrisLaLigne %W %x %y"
    #bind $w.frame.list <ButtonRelease-3> "DecrisLaLigne %W %x %y Efface"

    if { [regexp "AvecRetour" $Maniere] } {
        tkwait variable VariableDeRetour($w)
        set v $VariableDeRetour($w)
        unset  VariableDeRetour($w)
        catch {destroy $w}
        return $v
    } else {
        return $w
    }
}

proc TouchePour {Clavier Texte {Commande ""} {Action ""} {Couleur ""}} {

    global TouchePour

    if {[regexp "<" $Clavier]} {
        set Bouton [set TouchePour(BoutonCourant)]
        set NewTexte [lindex [$Bouton configure -text] 4]
        append NewTexte $Texte
        $Bouton configure -text $NewTexte 
        bind $Bouton $Clavier $Commande
        return $Bouton
    }

    if {$Texte=="NouvelleCouleur"} {
        set TouchePour($Clavier,Couleur) $Commande
        return [set TouchePour($Clavier,Couleur)]
    }

    if {$Texte=="NouvelleGamme"} {
        if { ! [info exists TouchePour($Clavier,Gamme)]} {
            set TouchePour($Clavier,Gamme) -1
        }
        set Gamme [incr TouchePour($Clavier,Gamme)]
        set    DestFrame "$Clavier.gamme$Gamme"
        frame $DestFrame
         pack $DestFrame -side "left" -fill x -pady 0 -anchor "n"
        set TouchePour($Clavier,DestFrame) $DestFrame
        return $DestFrame
    }

    if {$Action=="NoWeb"} { set NoWeb 1 } else { set NoWeb 0 }
    if {$NoWeb && [PourWscope]} { return "" }

    if { ! [info exists TouchePour($Clavier,nTouches)]} {
        set TouchePour($Clavier,nTouches) -1
    }
    if { ! [info exists TouchePour($Clavier,Couleur)]} {
        set TouchePour($Clavier,Couleur) "grey"
    }
    set B [incr TouchePour($Clavier,nTouches)]
    if {$Couleur==""} {
        set Couleur [set TouchePour($Clavier,Couleur)]
    }

    set Bouton "$Clavier.touche$B"
    button $Bouton -text $Texte -background $Couleur -foreground black -relief raise -width 15 -height 1 -pady 0
      bind $Bouton <1> $Commande

    pack $Bouton -in [set TouchePour($Clavier,DestFrame)] -side "top" -expand 1

    set TouchePour(BoutonCourant) $Bouton
    return $Bouton
}

proc BoutonneLaFenetre {Fenetre Texte {Commande ""}} {
    set NdB [NomDe bouton]
    if {$Commande==""} {
	button $Fenetre.buttons$NdB -text $Texte -relief raised -padx 3
    } else {
	button $Fenetre.buttons$NdB -text $Texte -relief raised -command $Commande
    }
    pack $Fenetre.buttons$NdB -side right -expand 1
    return "$Fenetre.buttons$NdB"
}

proc EditAndShow {Texte {FichierPourSave ""} {Maniere ""}} {
    return [AfficheVariable [EntreTexte $Texte] "AvecFormate$Maniere" $FichierPourSave]
}

proc RepertoireDuGenome {{Repertoire ""}} {
    global env
    global RepertoireDuGenome
    global FichierMiniConfig
    global GscopeDir

    if {$Repertoire!=""} {
	set RepertoireDuGenome $Repertoire
    }
    if { ! [info exists RepertoireDuGenome]} {
	if {[info exists env(REPERTOIREDUGENOME)]} {
	    set RepertoireDuGenome $env(REPERTOIREDUGENOME)
	} else {
	    set RepertoireDuGenome [tk_chooseDirectory \
		    -mustexist 1 \
		    -title "Please browse for the root directory of your data" \
		    -initialdir "$GscopeDir/.."]
	}
    }
    if {[info exists RepertoireDuGenome]} {
	set FichierMiniConfig "$RepertoireDuGenome/beton/miniconfig"
	return $RepertoireDuGenome
    }
    Warne "Please use  setgscope subdirectory_of_~/genomes"
    Warne "    or change your program to  Gscope directory_of_the_genome"
    exit
}

proc RepertoireDeTravail {{JunkDir ""}} {
    global RepertoireDeTravail
    #global env

    if {[info exists RepertoireDeTravail]} { return $RepertoireDeTravail }
    if {$JunkDir == ""} {
	set JunkDir "[TEMPDIR]"
	#set JunkDir "[HOMEDIR]/junkdir"
    }
    if {[file isdirectory $JunkDir]} {
	set RepertoireDeTravail $JunkDir
	return $RepertoireDeTravail
    }
    if {[OuiOuNon "Can I create a Working directory\n$JunkDir\n ?"]} {
	file mkdir $JunkDir
	set     RepertoireDeTravail $JunkDir
	return $RepertoireDeTravail
    }
    if {[OuiOuNon "Do You want to choose an other Working directory ?"]} {
	set AutreJunkDir [Entre [pwd]]
    } else {
	set AutreJunkDir ""
    }
    set     RepertoireDeTravail [RepertoireDeTravail $AutreJunkDir]
    return $RepertoireDeTravail
}

proc Warne Texte {
    global WarneWindow
    global WarneEnPuts
    global WarneNon

    if {[info exists WarneNon] && $WarneNon} { return "" }

    if { ! [info exists WarneEnPuts]} { set WarneEnPuts 1 }

    if { [info exists WarneEnPuts] && $WarneEnPuts } { 
	puts $Texte
	return $Texte
    }

#    return ""
    Wup "La suite est a revoir si Warne dans fenetre"

    if { ! [info exists WarneWindow] || ! [winfo exists $WarneWindow]} {
	set WarneWindow [AfficheVariable "Warnings..." "" "Warnings"]
	wm iconify $WarneWindow 
    }

    $WarneWindow.frame.list insert end $Texte
    $WarneWindow.frame.list yview end
    update
    return $WarneWindow
}

proc Espionne Texte {
    global EspionneNon

    if {[info exists EspionneNon] && $EspionneNon} {return ""}

    puts $Texte
}

proc NomDe Machin {
    global NumeroDe
    if { ! [info exists NumeroDe] } {set NumeroDe 0000}
    incr NumeroDe
    return ".$Machin$NumeroDe"
}

proc Focalise {Fenetre {Action ""}} {
    global MotFocalise
    global PositionFocalise

    if {$Action=="ask"} { if {[info exists MotFocalise]} { unset MotFocalise } }
    if {$Action=="top"} { set PositionFocalise -1 }

    if { ! [info exists MotFocalise] } { 
	set MotFocalise [Entre ""]
	if {$MotFocalise==""} { return }
	set PositionFocalise -1
    }

    incr PositionFocalise

    set FenetreListBox $Fenetre.frame.list
    foreach Ligne [$FenetreListBox get $PositionFocalise end] {
	if { [regexp -nocase $MotFocalise $Ligne] } {
	    $FenetreListBox yview $PositionFocalise
	    $FenetreListBox selection set $PositionFocalise
	    return
	}
	incr PositionFocalise
    }
    set PositionFocalise -1
}

proc Entre {{Defo ""}} {
    global RetourEntre
    
    global EntreToujoursDefaut
    
    if {[info exists EntreToujoursDefaut] && $EntreToujoursDefaut} { return $Defo } 
    
    set w [NomDe fenetre]
    toplevel $w
    wm title $w "To validate <return> or <Button-3>"
    wm iconname $w ""
    wm geometry $w +300+300
    
    entry    $w.e -width 80 -borderwidth 10 -background red -foreground white -font {Courier 14}
    if { $Defo != "" } { $w.e  insert 0 $Defo }
    pack     $w.e -expand 1 -fill x
    focus    $w.e
    bind     $w.e <Button-3> "set RetourEntre($w) \[$w.e get\]"
    bind     $w.e <Return>   "set RetourEntre($w) \[$w.e get\]"
    tkwait variable RetourEntre($w)
    destroy $w
    set Retour [set RetourEntre($w)]
    unset RetourEntre($w)
    return $Retour
}

proc EntreTexte {{Defo ""} {BoutonsEnPlus ""}} {
    global RetourEntreTexte
    global FenetreInfoOuverte
    global PolicePourEntreTexte
    
    set w [NomDe fenetre]
    toplevel $w
    wm title $w "You can edit this text ... "
    wm iconname $w "Edit"
    
    set LesLignesDuTexte [split $Defo "\n"]
    set PremiereLigne [lindex $LesLignesDuTexte 0]
    if {[regexp {^Nom\: } $PremiereLigne]} {
	scan $PremiereLigne "%s %s" Bidon Nom
	set FenetreInfoOuverte($Nom) $w
    }
    
    set Hauteur [Mini 10 [Maxi 30 [llength $LesLignesDuTexte]]]
    set Largeur 80
    foreach Ligne $LesLignesDuTexte {
	set Largeur [Maxi $Largeur [string length $Ligne]]
    }
    set Largeur [Mini $Largeur 180]

    set Police 12
    if {[info exists PolicePourEntretexte]} { set Police $PolicePourEntreTexte }
    text  $w.text -wrap none -relief sunken -bd 2 \
	    -font [list Courier $Police] \
	    -xscrollcommand "$w.xscroll set" \
	    -yscrollcommand "$w.yscroll set" \
	    -width $Largeur -height $Hauteur
          $w.text insert 0.0 $Defo
    focus $w.text
    
    frame  $w.buttons
    pack   $w.buttons -side bottom -fill x -pady 2m
    
    button $w.buttons.dismiss -background red -text "Dismiss"
      bind $w.buttons.dismiss <1> "set RetourEntreTexte($w) \"\""
      pack $w.buttons.dismiss -side left -expand 1
    button $w.buttons.saveas -text "Save All/Sel."
      bind $w.buttons.saveas <1> "SaveAs \[$w.text get 1.0 end\]"
      bind $w.buttons.saveas <2> "SaveAs \[$w.text get sel.first sel.last\]"
      pack $w.buttons.saveas -side left -expand 1
    #button $w.buttons.aspect -text "Font"
    #  bind $w.buttons.aspect <1> "PolicePourEntreTexte Ask $w"
    #  pack $w.buttons.aspect -side left -expand 1
    #button $w.buttons.browse -text "Replace/Append/Choose\n(with other file)"
    #  bind $w.buttons.browse <1> "ButineEtRemplace $w.text"
    #  bind $w.buttons.browse <2> "ButineEtAjoute $w.text"
    #  bind $w.buttons.browse <3> "ChoisiEtAjouteChampsInfo $w.text"
    #  pack $w.buttons.browse -side left -expand 1
    button $w.buttons.accept -text "Accept All/Sel." -background green -foreground black
      bind $w.buttons.accept <1> "set RetourEntreTexte($w) \[$w.text get 1.0 end\]"
      bind $w.buttons.accept <2> "set RetourEntreTexte($w) \[$w.text get sel.first sel.last\]"
      pack $w.buttons.accept -side left -expand 1
    if {$BoutonsEnPlus!=""} {
	set I 0
	foreach {T C} $BoutonsEnPlus { 
	    incr I
	    button $w.buttons.plus$I -text $T -background orange -foreground black
	      bind $w.buttons.plus$I <1> $C
	      pack $w.buttons.plus$I -side left -expand 1
	}
    }
    
    scrollbar $w.xscroll -command "$w.text xview" -orient "horizontal"
         pack $w.xscroll -side bottom -fill x
    scrollbar $w.yscroll -command "$w.text yview"
         pack $w.yscroll -side right -fill y
    
    pack $w.text -expand yes -fill both
    
    tkwait variable RetourEntreTexte($w)
    if {[info exists RetourEntreTexte($w)]} {
	set Retour [set RetourEntreTexte($w)]
	unset RetourEntreTexte($w)
    } else {
	set Retour ""
    }
    destroy $w
    regsub {\n$} $Retour "" Retour
    return $Retour
}

proc AppendAuFichier {Fichier Ligne} {
    set Canal [open $Fichier "a"]
    puts $Canal $Ligne
    close $Canal
    return $Fichier
}

proc Sauve {Texte dans Fichier} {
    set f [open $Fichier w]
    if { $Texte != "" } { puts $f $Texte }
    close $f
    return $Fichier
}

proc PremiereLigneDuFichier Fichier {
    if { $Fichier == "" } {return ""}
    set f [open $Fichier r]
    if {[gets $f Ligne]<0} { set Ligne "" } 
    close $f
    return $Ligne
}

proc FichierPourSaveAs {{RepertoireEtFichier "unnamed"}} {
    global RepertoireInitial

    if {[regexp {/$} $RepertoireEtFichier]} {
	regsub {/$} $RepertoireEtFichier "" Rep
	set Fic ""
    } else {
	set Rep [file dirname $RepertoireEtFichier]
	set Fic [file tail $RepertoireEtFichier]
    }
    if {$Rep!=""} {
	set RepertoireInitial $Rep
    }
    if {$Fic!=""} {
	set FichierInitial "$Fic"
    }

    if { ! [info exists RepertoireInitial]} { set RepertoireInitial [pwd] } 
    if { ! [info exists FichierInitial]}    { set FichierInitial "unnamed"} 

    set Fichier  [tk_getSaveFile -title "File to create" \
	    -initialfile $FichierInitial \
	    -initialdir $RepertoireInitial]
    if { $Fichier == "" } { return ""}
    set RepertoireInitial [file dirname $Fichier]
    return $Fichier
}

proc SaveAs {Page {RepertoireEtFichier "unnamed"}} {
    set Fichier [FichierPourSaveAs $RepertoireEtFichier]
    if {$Fichier==""} { return "" }
    return [Sauve $Page dans $Fichier]
}

proc ChoixParmiJoli {Liste {ListeDeCouleurs {}} {ListeAAfficher {}}} {
    global retourChoixParmi

    if {[llength $Liste] == 0 } { return "" }
    if {[llength $Liste] == 1 && [lindex $Liste 0]!="Other"} { return [lindex $Liste 0] }

    global ChoixParmiDansListBox
    if {([info exists ChoixParmiDansListBox] && $ChoixParmiDansListBox) || [llength $Liste]>40} {
	return [ChoixParmiDansListBox $Liste $ListeAAfficher]
    }

    set w [NomDe fenetre]
    catch {destroy $w}
    catch {unset retourChoixParmi}
    toplevel $w
    wm geometry $w +300+100

    set Invite "Choose ..."
    set InListBox "Same display in a listbox"
    set Salut  "... DISMISS"

    if {$ListeAAfficher=={}} { set ListeAAfficher $Liste }

    tk_optionMenu $w.o retourChoixParmi $Invite
    $w.o.menu add radiobutton -label $InListBox -background "orange" -variable retourChoixParmi
    $w.o configure -background "Seagreen" -foreground "black" -bd 20
    foreach Element $Liste Couleur $ListeDeCouleurs Affiche $ListeAAfficher {
	while {[info exists MonRetour($Affiche)]} { append Affiche "_" } 
	set MonRetour($Affiche) $Element
	if { $Couleur == "" } {
	    set Couleur "Seagreen"
	}
	$w.o.menu add radiobutton -background $Couleur -foreground "black" \
		-label $Affiche -variable retourChoixParmi
    }
    $w.o.menu add radiobutton -label $Salut -background "red" -variable retourChoixParmi
    
    pack $w.o

    tkwait variable retourChoixParmi
    destroy $w
    if { $retourChoixParmi == $InListBox } {
	set retourChoixParmi [ChoixParmiDansListBox $ListeAAfficher]
    }
    if { $retourChoixParmi == $Invite || $retourChoixParmi == $Salut } {
	set retourChoixParmi ""
    }
    if {$retourChoixParmi==""} { return "" }
    set Retour [set MonRetour($retourChoixParmi)]
    return $Retour
}

proc ChoixParmi {Liste {ListeDeCouleurs {}}} {
    global retourChoixParmi

    if {[llength $Liste] == 0 } { return "" }
    if {[llength $Liste] == 1 } { return [lindex $Liste 0] }

    #global ChoixParmiDansListBox
    #if {[info exists ChoixParmiDansListBox] && $ChoixParmiDansListBox \
#	|| [llength $Liste]>40} {
#	return [ChoixParmiDansListBox $Liste]
#    }

    set w [NomDe fenetre]
    catch {destroy $w}
    catch {unset retourChoixParmi}
    toplevel $w
    wm geometry $w +300+100

    set Invite "Choose ..."
    #set InListBox "Same display in a listbox"
    set Salut  "... DISMISS"

    tk_optionMenu $w.o retourChoixParmi $Invite
    #$w.o.menu add radiobutton -label $InListBox -background "orange" -variable retourChoixParmi
    $w.o configure -background "Seagreen" -foreground "black" -bd 20
    foreach Element $Liste Couleur $ListeDeCouleurs {
	if { $Couleur == "" } {
	    set Couleur "Seagreen"
	}
	$w.o.menu add radiobutton -background $Couleur -foreground "black" \
		-label $Element -variable retourChoixParmi
    }
    $w.o.menu add radiobutton -label $Salut -background "red" -variable retourChoixParmi
    
    pack $w.o

    tkwait variable retourChoixParmi
    destroy $w
    #if { $retourChoixParmi == $InListBox } { return [ChoixParmiDansListBox $Liste] }
    if { $retourChoixParmi == $Invite || $retourChoixParmi == $Salut } {
	set retourChoixParmi ""
    }
    return $retourChoixParmi
}

proc ChoixParmiDansListBox {Liste {ListeAAfficher {}}} {
    set Choose "Select ONE of the following lines and press ACCEPT. Press DISMISS to cancel."
    if {$ListeAAfficher=={}} {
	set ListeA $Liste
    } else {
	set ListeA $ListeAAfficher
    }
    set ListeE [concat [list ""] $Liste]
    set ListeA [concat [list $Choose] $ListeA]
    foreach E $ListeE A $ListeA {
	while {[info exists ARetourner($A)]} {
	    set A "$A (bis)"
	}
	set ARetourner($A) $E
	lappend BonneListeA $A
    }
    set Texte [join $BonneListeA "\n"]
    set Retour [Affiche $Texte "AvecRienSansFetchAvecRetour" "SelectAndAccept"]
    if {$Retour==$Choose || $Retour==""} { return "" }
    return [set  ARetourner($Retour)]
}

proc FaireLire Message {
    global FaireLireNon

    if {[info exists FaireLireNon] && $FaireLireNon} { return }
    if {[string length $Message] > 1000} {
	set Message "[string range $Message 0 499]\n ... \n ... [string range $Message end-499 end]"
    }
    after idle {.fairelire.msg configure -wraplength 10i -background red}
    tk_dialog .fairelire "Please press OK" "$Message" {} 0 Acknowledge
    catch {destroy .fairelire}
    update
}

proc Wup Texte {
 
}

proc Gs TypeDeRetour {
    # Differents types de retour :
    # Rien
    # Text
    # Frame
}

proc OuiOuNonMemo {Message {ReponseParDefaut ""} {Value 1}} {
    global OuiOuNonMemo

    if {$Message=="UnsetAllPlease"} {
	if {[info exists OuiOuNonMemo]} { unset OuiOuNonMemo }
	return 1
    }
    if {$ReponseParDefaut=="SetItPleaseTo"} {
	if {[info exists OuiOuNonMemo($Message)]} {
	    set OldRep [set OuiOuNonMemo($Message)]
	} else {
	    set OldRep -1
	}
	set OuiOuNonMemo($Message) $Value
	return $OldRep
    }

    if {$ReponseParDefaut=="UnsetItPlease"} {
	if { ! [info exists OuiOuNonMemo($Message)]} { return -1 }
	set OldRep [set OuiOuNonMemo($Message)]
	unset OuiOuNonMemo($Message)
	return $OldRep
    }

    if {[info exists OuiOuNonMemo($Message)]} { return [set OuiOuNonMemo($Message)] }

    set Reponse [OuiOuNon $Message $ReponseParDefaut]
    set OuiOuNonMemo($Message) $Reponse
    return $Reponse
}

proc OuiOuNon {Message {ReponseParDefaut ""}} {
    global OuiOuNonToujoursParDefaut
    
    Gs "Rien"

    if {$ReponseParDefaut==""} { set ReponseParDefaut 1 }

    if {$ReponseParDefaut} {
	set IndexReponse 0
    } else {
	set IndexReponse 1
    }

    if {[info exists OuiOuNonToujoursParDefaut] && $OuiOuNonToujoursParDefaut} { return $ReponseParDefaut }
    
    set Demandeur ""
    catch {set Demandeur [PreFixe]}
    if {$Demandeur!=""} { set Demandeur "(for $Demandeur)" }

    after idle {.ouiounon.msg configure -wraplength 10i -foreground white -background red}
    set R [tk_dialog .ouiounon "$Demandeur Please press Yes or No" "$Message" {} $IndexReponse "Yes" "No" "?"]
    if {$R==2} {
	set L [info level]
	set CalledBy ""
	for {set L [info level]} {$L>=0} {incr L -1} {
	    lappend LeTexte "$CalledBy [info level $L]"
	    set CalledBy "called by  "
	}
	FaireLire [join $LeTexte "\n"]
	set Reponse [OuiOuNon $Message $ReponseParDefaut]
    } else {
	set Reponse [expr {1-$R}]
    }
    destroy .ouiounon
    return $Reponse
}

proc Affiche {Page {Maniere ""} {NomDuFichierOrigine ""}} {
    return [AfficheVariable $Page $Maniere $NomDuFichierOrigine]
}

proc AfficheLesFichiers {Selection {Maniere ""}} {
    set Dernier ""
    foreach Ligne [split $Selection "\n"] {
	foreach Fichier [split $Ligne " "] {
	    if {! [file exists $Fichier]} {continue}
	    set Dernier [AfficheFichier $Fichier $Maniere]
	}
    }
    return $Dernier
}

proc AfficheFichier {Fichier {Maniere ""}} {

    Gs "Frame"
    
    if { $Fichier == "" } return ""
    if { ! [file exists $Fichier]} {
	FaireLire "I wanted to show the file \n$Fichier\n It doesn't exist. Sorry."
	return ""
    }
    if {[file isdirectory $Fichier]} {
	set Page "[file dirname $Fichier]\n"
	if { ! [regexp "/" $Page]} { set Page "./$Page" }
	append Page [join [lsort [glob -nocomplain "$Fichier/*"]] "\n"]
    } else {
	set Page [ContenuDuFichier $Fichier]
    }
    return [AfficheVariable $Page $Maniere $Fichier]
}

proc ContenuDuFichier {{Fichier ""}} {
    if { $Fichier == "" } {return ""}
    set f [open $Fichier r]
    set Texte [read -nonewline $f]
    close $f
    return $Texte
}

proc LesLignesDuFichier {{Fichier ""}} {
    return [split [ContenuDuFichier $Fichier] "\n"]
}

proc Mini {a b} {
    if {$a<$b} { return $a } else { return $b }
}

proc Maxi {a b} {
    if {$a<$b} { return $b } else { return $a }
}

proc MaxiDeLaListe LesX {
    set MaxX [lindex $LesX 0]
    foreach X $LesX {
	set MaxX [Maxi $X $MaxX] 
    }
    return $MaxX
}

proc MainLevee {K x y Action} {
    global IdScrollRectangle
    global LesCouleursPourMainLevee
    global LesTaillesPourMainLevee
    global DernierXDuTouche DernierYDuTouche
    global BufferMainLevee

    set X [$K canvasx $x]
    set Y [$K canvasy $y]

    set Touche [$K find withtag current]
    if {[info exists IdScrollRectangle($K)] && $Touche==[set IdScrollRectangle($K)]} {
	if {[regexp "Point|Motion" $Action]} { return }
    }

    set ItemType [$K type $Touche]

    if {$Action == "Motion"} {
	$K move $Touche [expr {$x-$DernierXDuTouche}] [expr {$y-$DernierYDuTouche}]
	set DernierXDuTouche $x
	set DernierYDuTouche $y
	return
    }

    if {$Action == "Point"} {
	set DernierXDuTouche $x
	set DernierYDuTouche $y
	return
    }

    if {$Action=="Modif"} {
	set LesActions {"Erase" "Size" "Color" "Raise" "Lower" "Copy" "Paste" "EditWidget" "New"}
	if {$ItemType=="text"} { lappend $LesActions "Text" } 
	set Action [ChoixParmi $LesActions]
	if {$Action == "" } { return }
    }

    if {$Action == "Erase"} {
	if { ! [OuiOuNon "Do you really want to erase this $ItemType"]} {
	    return 0
	}
	$K delete $Touche
	return 1
    }

    if {$Action == "Raise"} {
	$K raise $Touche
	return "Raise"
    }
    if {$Action == "Lower"} {
	$K lower $Touche
	if {[info exists IdScrollRectangle($K)]} { $K lower [set IdScrollRectangle($K)]}
	return "Lower"
    }
    
    if {$Action == "Color"} {
	set OldCouleurFill [$K itemcget $Touche -fill]
	if {[set CouleurFill [UneCouleurPourMainLevee $OldCouleurFill]]=="Cancel"} { return "" }
	$K itemconfigure $Touche -fill $CouleurFill

	if { ! [regexp "arc|polygon|rectangle" $ItemType] || \
		! [OuiOuNon "Do You want to change the Outline Color ?"]} { return $CouleurFill }

	set OldCouleurOutline [$K itemcget $Touche -outline]
	if {[set CouleurOutline [UneCouleurPourMainLevee $OldCouleurOutline]]=="Cancel"} { return "" }
	$K itemconfigure $Touche -outline $CouleurOutline
	return $CouleurFill
    }

    if {$Action == "Size"} {
	if {[set Taille [UneTaillePourMainLevee]]==""} { return }

	ScanLaListe [Barycentre [$K coords $Touche]] CX CY
	$K scale $Touche $CX $CY $Taille $Taille
	
	if {$ItemType == "arc" && $Taille == "Copy"} {
	    set Extent [$K itemcget $Touche -extent]
	    $K itemconfigure $Touche -extent [expr $Extent*[Entre 0.9]]
	    return
	}
	if {$ItemType == "arc" && $Taille == "Extent"} {
	    set Extent [$K itemcget $Touche -extent]
	    $K itemconfigure $Touche -extent [expr $Extent*[Entre 0.9]]
	    return
	}
	if {$ItemType == "line" && $Taille == "Arrow"} {
	    set AvAr [$K itemcget $Touche -arrow]
	    if {$AvAr=="first"} { set AvAr "last" } else { set AvAr "first" }
	    $K itemconfigure $Touche -arrow $AvAr
	    return 
	}
	if {$Taille == "Other"} {
	    set Taille [Entre 21]
	    if {$Taille == ""} { return "" }
	    lappend LesTaillesPourMainLevee $Taille
	}
	if { $ItemType=="arc" || $ItemType=="line" } {
	    $K itemconfigure $Touche -width $Taille
	    return $Taille
	}
	if { $ItemType=="text"} {
	    $K itemconfigure $Touche -font [list Courier $Taille]
	    return $Taille
	}
    }
    if {$Action == "Text"} {
	set Texte [Entre [$K itemcget $Touche -text]]
	if {$Texte == ""} { return "" }
	if { $ItemType=="text"} {
	    $K itemconfigure $Touche -text $Texte
	    return $Texte
	}
    }
    if {$Action == "Copy"} {
	set Nouveau [RenaissanceDuWidget $K $Touche "Copy"]
	return $Nouveau
    }
    if {$Action == "Paste"} {
	if { ! [info exists BufferMainLevee]} {
	    FaireLire "You never made a Copy"
	    return ""
	}
	regsub {^[^ ]+ } $BufferMainLevee "$K " Nouveau
	catch {set NouveauId [eval $Nouveau]} Message
	if {[regexp {[^0-9]} $Message]} {
	    FaireLire "I got this message : \n$Message"
	    return ""
	}
	return $NouveauId
    }
    if {$Action == "EditWidget"} {
	set Nouveau [RenaissanceDuWidget $K $Touche]
	return $Nouveau
    }
    if {$Action == "New"} {
	set Nouveau [CreerUnWidget $K]
	return $Nouveau
    }
}

proc MainLeveeSurUnCanva K {
    global IdScrollRectangle

    $K bind "all"      <1>               "MainLevee $K %x %y Point"
    $K bind "all"      <B1-Motion>       "MainLevee $K %x %y Motion"
    $K bind "all"      <ButtonRelease-1> "MainLevee $K %x %y Relache"
    $K bind "all"      <Control-3>       "MainLevee $K %x %y Modif"

    regsub {\.[a-z_0-9]+$} $K "" w

    set Bouton [BoutonneLaFenetre $w "Save/Restore/Erase"]
    bind $Bouton <1> "SauveLeCanva $K all"
    bind $Bouton <2> "RestaureLeCanva $K"
    bind $Bouton <3> "EraseLeCanva $K"
}

proc FermeFenetre {} {
}

proc PolicePourListBox {{PoliceOuAsk ""} {W ""}} {
    global PolicePourListBox

    Wup "returns or sets the current fontsize, asks if PoliceOuAsk is 'Ask' "

    if { ! [info exists PolicePourListBox]} { set PolicePourListBox 10 }

    if {[regexp {^[0-9]+$} $PoliceOuAsk]} {
	set PolicePourListBox $PoliceOuAsk
    } elseif {[regexp -nocase {^Ask$} $PoliceOuAsk]} {
	set Police [ChoixParmi {6 8 10 12 14 16 18 20 22 24}]
	if {$Police!=""} { set PolicePourListBox $Police }
    }
    if {$W!=""} { $W.frame.list configure -font [list Courier $PolicePourListBox] }
    return $PolicePourListBox
}

proc NombresEntre {D F {Pas 1}} {
    if {$D==$F} { return [list $D] }
    set LesX {}
    for {set X $D} {[expr $Pas*$X <= $Pas*$F]} { set X [expr {$X+$Pas}]} {
	lappend LesX $X
    }
    return $LesX
}

proc FormateSequence {Sequence {NouveauFormat ""} {AncienFormat ""}} {
    if {$AncienFormat==""} { set AncienFormat [FormatDeLaSequence $Sequence] }
    if {$NouveauFormat==""} {
	set LesNouveauxPossibles [list \
		"to-TFA" \
		"to-EMBL" \
		"to-GCG" \
		"TFA-to-reverse-TFA" \
		"TFA-to-complement-TFA" \
		"TFA-to-rev-and-comp-TFA" \
		]
	set N [llength $LesNouveauxPossibles]
	set I [ChoixParmiJoli [NombresEntre 1 $N] "" $LesNouveauxPossibles]
	if {$I==""} { return "" }
	set NouveauFormat [lsearch $LesNouveauxPossibles [expr {$I-1}]]
    }
    if { $AncienFormat == "tfas" && $NouveauFormat == "to-GCG" } {
	FaireLire "Multiple TFA to GCG is not yet possible"
	return ""
    }
    set II 0
    if { $I==[incr II]} { return [SequenceFormatTFA            $Sequence "" $AncienFormat]}
    if { $I==[incr II]} { return [SequenceFormatEMBL           $Sequence "" $AncienFormat]}
    if { $I==[incr II]} { return [SequenceFormatGCG            $Sequence "" $AncienFormat]}
    if { $I==[incr II]} { return [TFAToReverseTFA              $Sequence ""]}
    if { $I==[incr II]} { return [TFAToComplementTFA           $Sequence ""]}
    if { $I==[incr II]} { return [TFAToReverseAndComplementTFA $Sequence ""]}
    return ""
}

proc FormatDeLaSequence Sequence {

    Wup "returns tfa tfas embl gcg gcgmaybe nucbrut protbrut or Inconnu"

    regsub {!![NA]A_SEQUENCE 1.0\n} $Sequence "" Sequence
    
    if {[set iC [string first ">" $Sequence]]==0} {
	if {[set  iDL [string first "\n" $Sequence 1]]>1} {
	    if {[string first ">" $Sequence $iDL]>0} { return "tfas" } else {return "tfa"}
	}
    }

    if {[regexp "^ID  " $Sequence]} {
	if {[regexp {[^p\.]\.\.[ \t]*\n} $Sequence]} {
	    return "gcg"
	}
	return "embl"
    }

    if {[regexp {[^\.]\.\.[ \t]*\n} $Sequence]} { return "gcgmaybe" }

    if {[regexp -nocase {[^a-zA-Z0-9\.\n\t \*]} $Sequence]} { return "Inconnu" } 

    if {[regexp -nocase {[^ATGCX0-9\.\n\t \*]} $Sequence]} { return "protbrut" } 
    return "nucbrut"
}

proc TFAToComplementTFA {TFA {Entete ""}} {
    if {$Entete==""} {
	set OldEntete [EnteteDuTexteTFA $TFA All]
	regsub ">" $OldEntete ">Com_" $Entete
    }
    set Seq [QueLaSequenceDuTexteTFA $TFA]
    set Com [NucToComplementNuc $Seq]
    set NewTFA [SequenceFormatTFA $Com $Entete "brut"]
    return $NewTFA
}

proc TFAToReverseTFA {TFA {Entete ""}} {
    if {$Entete==""} {
	set OldEntete [EnteteDuTexteTFA $TFA All]
	regsub ">" $OldEntete ">Rev_" $Entete
    }
    set Seq [QueLaSequenceDuTexteTFA $TFA]
    set Rev [NucToReverseNuc $Seq]
    set NewTFA [SequenceFormatTFA $Rev $Entete "brut"]
    return $NewTFA
}

proc TFAToReverseAndComplementTFA {TFA {Entete ""}} {
    if {$Entete==""} {
	set OldEntete [EnteteDuTexteTFA $TFA All]
	regsub ">" $OldEntete ">RevAndCom_" $Entete
    }
    set Seq [QueLaSequenceDuTexteTFA $TFA]
    set RevCom [NucToReverseAndComplementNuc $Seq]
    set NewTFA [SequenceFormatTFA $RevCom $Entete "brut"]
    return $NewTFA
}

proc NucToReverseAndComplementNuc Seq {
    set Rev [NucToReverseNuc $Seq]
    set Com [NucToComplementNuc $Rev]
    return $Com
}

proc NucToComplementNuc Seq {
    set Com ""
    foreach B [split $Seq ""] {
	append Com [ComplementNuc $B]
    }
    return $Com
}

proc NucToReverseNuc Seq {
    set Rev ""
    for {set i [expr [string length $Seq]-1]} {$i>=0} {incr i -1} {
	append Rev [string index $Seq $i]
    }
    return $Rev
}

proc ComplementNuc Nuc {
    global ComplementNuc

    if {[info exists ComplementNuc($Nuc)]} { return [set ComplementNuc($Nuc)] }
    if {[info exists ComplementNuc]} { return $Nuc }

    set ComplementNuc(X) "X"
    set ComplementNuc(x) "x"
    set ComplementNuc(A) "T"
    set ComplementNuc(T) "A"
    set ComplementNuc(G) "C"
    set ComplementNuc(C) "G"
    set ComplementNuc(a) "t"
    set ComplementNuc(t) "a"
    set ComplementNuc(g) "c"
    set ComplementNuc(c) "g"
    set ComplementNuc(N) "N"
    set ComplementNuc(n) "n"

    set ComplementNuc(M) "K"
    set ComplementNuc(K) "M"
    set ComplementNuc(R) "Y"
    set ComplementNuc(Y) "R"
    set ComplementNuc(W) "W"
    set ComplementNuc(S) "S"
    
    set ComplementNuc(m) "k"
    set ComplementNuc(k) "m"
    set ComplementNuc(r) "y"
    set ComplementNuc(y) "r"
    set ComplementNuc(w) "w"
    set ComplementNuc(s) "s"
    
    set ComplementNuc(V) "B"
    set ComplementNuc(H) "D"
    set ComplementNuc(D) "H"
    set ComplementNuc(B) "V"
    set ComplementNuc(v) "b"
    set ComplementNuc(h) "d"
    set ComplementNuc(d) "h"
    set ComplementNuc(b) "v"

    return [ComplementNuc $Nuc]
}

proc SequenceFormatGCG {Sequence {NomDeBapteme ""} {Format ""}} {

    Wup "Converts to GCG but doesn't yet  use NomDeBapteme"

    NousAllonsAuBoulot

    set Long [string length $Sequence]
    set FichierTmpTfa "[TmpFile].tfa"
    regsub ".tfa$" $FichierTmpTfa ".list" FichierTmpList
    Sauve [SequenceFormatTFA $Sequence $NomDeBapteme $Format] dans $FichierTmpTfa
    exec fromfasta -begin=1 -end=$Long -protein $FichierTmpTfa -List=$FichierTmpList
    if { ! [file exists $FichierTmpList]} {
	File delete -force $FichierTmpTfa
	return "Error : I couln't find the list of filenames."
    } 
    foreach Ligne [LesLignesDuFichier $FichierTmpList] {
	if { ! [info exists DejaVuPP]} {
	    if {[regexp {\.\. *$} $Ligne ]} { continue }
	    set DejaVuPP 1
	}
	set FichierTmpPep ""
	scan $Ligne "%s" FichierTmpPep
	if {$FichierTmpPep==""} { continue }
    }
    if { ! [file exists $FichierTmpPep]} {
	File delete -force $FichierTmpTfa
	File delete -force $FichierTmpList
	return "Error : I couln't find the converted file"
    }
    set GCG [ContenuDuFichier $FichierTmpPep]
    File delete -force $FichierTmpTfa
    File delete -force $FichierTmpPep
    File delete -force $FichierTmpList

    OnRevientDuBoulot
    return $GCG
}

proc SequenceFormatTFA {Sequence {NomDeBapteme ""} {Format ""} } {
    Wup "Sequence peut etre une sequence au format Format ou du simple texte"

    set NomParDefaut "unamed"
    if {$NomDeBapteme==""} { set NomDeBapteme $NomParDefaut }

    if {[set ForceHeader [regexp "^ForceHeaderTo=" $NomDeBapteme]]} {
	regsub "^ForceHeaderTo=" $NomDeBapteme "" NomDeBapteme
    }

    if {$Format == ""} { set Format [FormatDeLaSequence $Sequence] }
    if {$Format=="tfa" || $Format=="tfas"} { return $Sequence } 

    if {$Format=="embl"} {
	set LesLignesEMBL [split $Sequence "\n"]
	DecortiqueLesLignesEMBL $LesLignesEMBL ID AC DE GN OS OC OX SequenceBrute
	if {$ForceHeader} {
	    set Entete $NomDeBapteme
	} else {
	    if {$NomDeBapteme==$NomParDefaut} { set NomDeBapteme $AC }
	    set Entete [string range "$NomDeBapteme $AC $DE" 0 998]
	}
	regsub -all {>} $Entete " " Entete
	set Entete [string trim $Entete]
	set TFA ">$Entete\n[SequenceFormatBrut $SequenceBrute]"
	return $TFA
    }
    if {$Format=="gcg" || $Format=="gcgmaybe"} {

	set LesLignesGCG [split $Sequence "\n"]

	set iAC [lsearch -regexp $LesLignesGCG "^AC "]
	if {$iAC>0} {
	    scan [lindex $LesLignesGCG $iAC] "%s %s" Cle Access
	    regsub -all {[^a-zA-Z0-9_]} $Access "" Access
	} elseif { [set iACCESSION [lsearch -regexp $LesLignesGCG "^ACCESSION "]] > -1 } {
	    scan [lindex $LesLignesGCG $iACCESSION] "%s %s" Cle Access
	    regsub -all {[^a-zA-Z0-9_]} $Access "" Access
	} else {
	    set Access ""
	}

	set DE ""
	set iDE [lsearch -regexp $LesLignesGCG "^DE "]
	if {$iDE>0} {
	    set DE [string range [lindex $LesLignesGCG $iDE] 5 end]
	} elseif { [set iDEFINITION [lsearch -regexp $LesLignesGCG "^DEFINITION "]] > -1 } {
	    set DE [string trim [string range [lindex $LesLignesGCG $iDEFINITION] 11 end]]
	    while {[regexp {^          } [lindex $LesLignesGCG [incr iDEFINITION]]]} {
		append DE " [string trim [lindex $LesLignesGCG $iDEFINITION]]"
	    }
	} else {
	    set DE ""
	}

	set iPP [lsearch -regexp $LesLignesGCG {\.\.}]
	set SequenceBrute [join [lrange $LesLignesGCG [incr iPP] end] ""]
	regsub -all {[0-9\n \t]} $SequenceBrute "" SequenceBrute
	if {$NomDeBapteme==$NomParDefaut && $Access!=""} { set NomDeBapteme $Access }
	set Entete [string range "$NomDeBapteme $Access $DE" 0 998]
	regsub -all {>} $Entete " " Entete
	set Entete [string trim $Entete]
	set TFA ">$Entete\n[SequenceFormatBrut $SequenceBrute]"
	return $TFA
    }
    if {$Format=="brut" || $Format=="protbrut" || $Format=="nucbrut"} {
	set Entete $NomDeBapteme
	regsub -all {>} $Entete " " Entete
	set Entete [string trim $Entete]
	set TFA ">$Entete\n[SequenceFormatBrut $Sequence]"
	return $TFA
    }

    FaireLire "Unknown sequence format. I don't convert to TFA."
    return ""
}

proc SequenceFormatEMBL {Texte {NomDeBapteme ""} {Format ""}} {

    Wup "Je n'ai pas encore traite le NomDeBapteme"

    if {$Format==""} { set Format [FormatDeLaSequence $Texte]}

    if {$Format=="embl"} { return $Texte }

    if {$Format=="tfa"} {
	set LesLignesTFA [split $Texte "\n"]
	set Premiere [lindex $LesLignesTFA 0]
	scan $Premiere "%s" Access
	regsub ">" $Access "" Access
	regsub ">$Access" $Premiere "" Definition
	set Definition [string trim $Definition]
	if {$Definition==""} {
	    set DE ""
	} else {
	    set DE "$Definition"
	}
	if {[regexp {\.{2,} *$} $DE]} { regsub {\.{2,} *$} $DE "" DE } 
	set Header "ID   $Access; created by CADO4MI.\nAC   $Access\nDE   $DE"
	regsub -all {[ 0-9/\n\t]} [join [lrange $LesLignesTFA 1 end] ""] "" Sequence
	set EMBL "$Header\n[QueSequenceFormatEMBL $Sequence AvecSQ]\n//"
	return $EMBL
    }
    if {$Format=="gcg"} {
	set LesLignesGCG [split $Texte "\n"]
	set ResteLaSequence 0
	foreach Ligne $LesLignesGCG {
	    if {$ResteLaSequence} {
		lappend LaSequence $Ligne
		continue
	    }
	    if {[regexp {[^.]\.\.[ \t]*$} $Ligne]} {
		set ResteLaSequence 1
		continue
	    }
	    if {[regexp {^[A-Z][A-Z]   } $Ligne]} {
		lappend lEmbl $Ligne
		set DerniereLigne $Ligne
	    }
	}
	set Sequence [join $LaSequence]
	regsub -all {[ 0-9/\n\t]} $Sequence "" Sequence
	if {[regexp "^SQ" $DerniereLigne]} {
	    lappend lEmbl [QueSequenceFormatEMBL $Sequence "SansSQ"]
	} else {
	    lappend lEmbl [QueSequenceFormatEMBL $Sequence "AvecSQ"]
	}
	return [join $lEmbl "\n"]
    }
    if {$Format=="gcgmaybe"} {
	set LesLignesGCG [split $Texte "\n"]
	set AttendPP 1
	foreach Ligne $LesLignesGCG {
	    if {$AttendPP} {
		if {[regexp {[^.]\.\.[ \t]*$} $Ligne]} {
		    set AttendPP 0
		}
		continue
	    }
	    if { ! [regexp -nocase {[A-Z]} $Ligne]} { continue }
	    lappend LaSequence $Ligne
	}
	set Sequence [join $LaSequence]
	regsub -all {[ 0-9/\n\t]} $Sequence "" Sequence
	if {$NomDeBapteme==""} {
	    set Access "Unknown"
	} else {
	    set Access $NomDeBapteme
	}
	set Header "ID   $Access; created by CADO4MI.\nAC   $Access"
	set EMBL "$Header\n[QueSequenceFormatEMBL $Sequence AvecSQ]\n\\"
	return $EMBL
    }
}

proc QueSequenceFormatEMBL {Seq {AvecSQ ""} {AvecReperes ""}} {

    if {$AvecSQ==""} { set AvecSQ "AvecSQ" }
    set AvecReperes [string equal -nocase $AvecReperes "AvecReperes"]

    Wup "Returns the EMBL format (lines of 6 groups of 10) from the string of AAs or NAs $Seq"
    Wup "Removes . and -"

    regsub -all -nocase {[^a-z]} $Seq "" Seq

    set Long [string length $Seq]

    if {$AvecSQ == "AvecSQ"} {
	if {[regexp -nocase {[MVLDEFHIKLPQRSVW]} $Seq Match]} {
	    set Texte "SQ   SEQUENCE   $Long AA;"
	} else {
	    set Texte "SQ   SEQUENCE   $Long Bp;"
	}
    }

    set nRepere 1
    set LesLignes {}
    set nDevant 9
    set Repere [string repeat " " [expr $nDevant+1]]
    set Ligne ""
    for {set i 0} {$i < $Long} {incr i} {
	if {$AvecReperes} { set Repere [format "%${nDevant}s " $nRepere] }
	if {[expr $i%60 == 0]} {
	    if {$Ligne != ""} { lappend LesLignes $Ligne }
	    set Ligne $Repere
	    incr nRepere 60
	}
	if { ! [expr $i%60 == 0] && [expr $i%10 == 0]} {append Ligne " " }
	append Ligne [string range $Seq $i $i]
    }
    set Tout [join $LesLignes "\n"]
    return $Tout
}
proc SequenceFormatBrut {Seq {CarParLigne ""} {DoVerify ""}} {
    global SequenceFormatBrutIn SequenceFormatBrutOut

    set DoVerify [expr ! [string equal -nocase $DoVerify "DoNotVerify"]]

    if {[info exists SequenceFormatBrutIn] && $Seq==$SequenceFormatBrutIn} {
	return $SequenceFormatBrutOut
    }
    set SequenceFormatBrutIn $Seq

    Wup "Returns text of lines of 50 residues."
    Wup "Keeps ."

    if {$CarParLigne==""} { set CarParLigne 50 }

    if {$DoVerify} {
	while {[regexp -nocase {\*$} $Seq]} { regsub {\*$} $Seq "" Seq } 
	if {[regexp -nocase {\*} $Seq]} {
	    FaireLire "$Seq\n contains *\n I'll replace them with x."
	    regsub -all {\*} $Seq "X" Seq
	}
	if {[regexp "\~" $Seq]} { regsub -all "\~" $Seq "." Seq }
	if {[regexp -nocase {[^0-9 \-\n\ta-z\.]} $Seq]} {
	    FaireLire "$Seq\n contains illegal characters\n I'll remove them." 
	}
	regsub -all -nocase {[^a-z\-\.]} $Seq "" Seq
    }
    if {$Seq == "" } { set SequenceFormatBrutOut "" ; return "" }
    for {set i 0} {$i < [string length $Seq]} { incr i $CarParLigne} {
	lappend ListeDesLignes [string range $Seq $i [expr $i+$CarParLigne-1]]
    }
    set SequenceFormatBrutOut [join $ListeDesLignes "\n"]
    return $SequenceFormatBrutOut
}

proc EnteteDuTexteTFA {Texte {Quoi "all"}} {
    set Entete ""
    foreach Ligne [split $Texte "\n"] {
	if {[regexp ">" $Ligne]} { set Entete $Ligne ; break }
    }
    if {[string tolower $Quoi]=="all"} { return $Entete }

    regsub ">" $Entete "" Entete
    set Access ""
    scan $Entete "%s" Access
    return $Access
}

proc EnteteDuFichierTFA {Fichier {Quoi "all"}} {
    return [EnteteDuTexteTFA [ContenuDuFichier $Fichier] $Quoi]
}

proc QueLaSequenceDuTexteTFA {Texte {MergeTFAs ""}} {

    if {$MergeTFAs==""} { set MergeTFAs "FirstOnly" }
    if {$MergeTFAs=="MergeTFAs"} { set Merge 1 ; set FirstOnly 0 ; set ListOfTxt 0 }
    if {$MergeTFAs=="FirstOnly"} { set Merge 0 ; set FirstOnly 1 ; set ListOfTxt 0 }
    if {$MergeTFAs=="ListOfTxt"} { set Merge 0 ; set FirstOnly 0 ; set ListOfTxt 1 }

    set LesSequences {}
    set Sequence ""
    set DejaVuChevron 0
    foreach Ligne [split $Texte "\n"] {
	if {[regexp ">" $Ligne]} {
	    if {$Merge} { continue }
	    if {$FirstOnly && $DejaVuChevron} { return $Sequence }
	    if {$ListOfTxt && $DejaVuChevron} {
		lappend LesSequences $Sequence
		set Sequence ""
	    }
	    set DejaVuChevron 1
	    continue
	}
	regsub -nocase -all -- {[^a-z\*\.\-]} $Ligne "" Ligne
	append Sequence $Ligne
    }
    if { ! $ListOfTxt} { return $Sequence }
    lappend LesSequences $Sequence
    return $LesSequences
}

proc QueLaSequenceDuTFA {Fichier {MergeTFAs ""}} {
    return [QueLaSequenceDuFichierTFA $Fichier $MergeTFAs]
}

proc QueLaSequenceDuFichierTFA {Fichier {MergeTFAs ""}} {
    return [QueLaSequenceDuTexteTFA [ContenuDuFichier $Fichier] $MergeTFAs]
}

proc EstUnAccessPDB Access {
    if { ! [regexp -nocase {^[0-9]+[a-z]+[0-9a-z_]*$} $Access] } { return 0 }
    if {[regexp -nocase {_[0-9a-z]{3,}} $Access] } { return 0 }
    return 1
}

proc LaManierePourAffiche TypeDeFichier {
    set PourNotes 0
    set PourNuc   0
    set PourProt  0
    set PourBlast 0
    set PourMSF   0

    set Rep [file tail [file dirname $TypeDeFichier]]
    #Espionne $Rep

    if {[regexp -nocase {^notes}    $Rep]} {
	set PourNotes 1
    }
    if {[regexp -nocase {^(copain|tfa)}    $Rep]} {
	set PourNuc 1
    }
    if {[regexp -nocase {nuctfa|nucembl}   $Rep]} {
	set PourNuc 1
    }
    if {[regexp -nocase {prottfa|protembl} $Rep]} {
	set PourProt 1
    }
    if {[regexp -nocase {(TBlast|Blast|Ballast)} $Rep]} {
	set PourBlast 1
    }
    if {[regexp -nocase {(MSF|Clustal|DbClustal)} $Rep]} {
	set PourMSF 1
    }

    set LesAvecs {}
    if {$PourNuc}   { lappend LesAvecs "AvecBlaste" "AvecFormate"}
    if {$PourProt}  { lappend LesAvecs "AvecBlaste" "AvecFormate"}
    if {$PourBlast} { lappend LesAvecs "AvecAligneurs" "AvecSegAlignements" }

    set LesAvecs [lsort -unique $LesAvecs]
    return [join $LesAvecs ""]    
}

proc OffreLesMots {Texte} {

    regsub -all {[\|\n\;\,?]} $Texte " " Texte
    regsub -all { +} $Texte " " Texte
    return [AfficheVariable [join [split $Texte " "] "\n"] "AvecShow" "Splitted_line"]
}

proc LaSequenceDesBanques {BanqueId {Access ""} {aAccessOK ""} {OnVeutEMBL ""} {NouveauPABCourant ""}} {
    if {$aAccessOK!=""} { upvar $aAccessOK AccessOK }

    #global RepertoireDuGenome
    global LesLignesEMBLEnMemoire
    global AccessOKEnMemoire
    global ConfigChargee
    global QuidSeqEstDisponible
    global PABCourant
    global EviteSPTNEW

    if {[regexp -nocase "VARSPLIC\:" $BanqueId]} {
	regsub -nocase "VARSPLIC" $BanqueId "PROT" ProtId
	regsub -nocase "VARSPLIC\:" $BanqueId ""     AccessOK
	if {[regexp {_[0-9]+$} $ProtId]} {
	    regsub {_[0-9]+$} $ProtId "" ProtId
	}
	if {[regexp {\-[0-9]+$} $ProtId]} {
	    regsub {\-[0-9]+$} $ProtId "" ProtId
	}
	set LesLignesEMBL [LaSequenceDesBanques $ProtId]
	if {$LesLignesEMBL==""} { set AccessOK "" ; return "" }
	set SeqTFA [TfaDeLaBanqueBlast "/blast/varsplic" $BanqueId]
	if {$SeqTFA==""} {
	    if {[regexp {_[0-9]+$} $BanqueId]} { regsub "_" $BanqueId "-" BanqueId }
	    set SeqTFA [TfaDeLaBanqueBlast "/blast/varsplic" $BanqueId]
	    if {$SeqTFA==""} { set AccessOK "" ; return "" }
	}
	set Seq [QueLaSequenceDuTexteTFA $SeqTFA]
	regsub "VARSPLIC\:" $BanqueId "" Id
	set LeNouveau {}
	foreach Ligne $LesLignesEMBL {
	    if {[regexp "^ID   " $Ligne]} {
		set Ligne "ID   $Id  VARSPLIC created by Gscope-varsplic.tcl from $ProtId"
	    }
	    if {[regexp "SQ   " $Ligne ]} {
		break
	    }
	    lappend LeNouveau $Ligne
	}
	lappend LeNouveau [QueSequenceFormatEMBL $Seq AvecSQ]
	return $LeNouveau
    }

    regsub -nocase "^RSHUM\:" $BanqueId "RSHUMAN:" BanqueId
    if {[regexp "RSHUMAN\:" $BanqueId]} { set Access "" } 

    if {$BanqueId==""} { set BanqueId $Access}
    if {$Access==""} { set Access $BanqueId }
    if {$BanqueId=="" && $Access==""} { return {} }
    if {[regexp "^OnVeut" $Access]} {
	set OnVeutEMBL $Access
	set Access $BanqueId
    }

    if { ! [info exists EviteSPTNEW]} { set EviteSPTNEW 1 }

    if {[EstUnAccessPDB $BanqueId] || $Access=="mol:protein"} { set Access $BanqueId }

    if { ! [regexp {\:} $BanqueId] && [regexp -nocase {(SPT|SW|SPTNEW)[_\|]} $BanqueId]} {
	regsub {[_\|]} $BanqueId ":" NewBanqueId
	if {$BanqueId==$Access} { set Access $NewBanqueId }
	set BanqueId $NewBanqueId
    }
    if {$BanqueId==$Access && [regexp ":" $Access] && ! [regexp -nocase "RSHUMAN\:" $Access]} {
	regsub -nocase {[a-z0-9_]+\:} $Access "" Access
    }
    if {$NouveauPABCourant!=""} { set PABCourant $NouveauPABCourant }

    Wup "Fetch the sequence. In EMBL format if OnVeutEMBL."
    Wup "BanqueId or Access ? First I try Access then BanqueId"

    Wup "Maybe I stored before in memory ..."
    if {[info exists LesLignesEMBLEnMemoire($BanqueId,$Access)]} {
	set LesLignesEMBL [set LesLignesEMBLEnMemoire($BanqueId,$Access)]
	set AccessOK [set AccessOKEnMemoire($BanqueId,$Access)]
	return $LesLignesEMBL
    }

    if {[regexp {^ci[0-9]{10}$} $Access]} {
	return [LesLignesDuFichier "/genomics/Ciona/protembl/[CioNarcisse $Access]"]
    }

    set Force 1
    set Previens 0

    set OnExigeNature 0
    if {$OnVeutEMBL == "OnVeutNature"} {
	set OnExigeNature 1
	set OnVeutEMBL ""
    }
    set OnExigeNuc 0
    if {$OnVeutEMBL == "OnVeutNucEMBL"} {
	set OnVeutEMBL "OnVeutEMBL"
	set OnExigeNuc 1
    }
    if {$OnVeutEMBL == "OnVeutEMBL"} {
	set OnVeutEMBL 1
    } else {
	set OnVeutEMBL 0
    }

    if {[regexp {^(ensembl|gp|pironly|remtrembl|worm)\:[a-zA-Z_0-9]+$} $BanqueId]} {
	set TFA [LaSequenceDuTFAs "/genomics/petitPDBscope/banques/nrdb_specific.tfa" $BanqueId]
	if {$TFA==""} { return {} }
	if {$OnVeutEMBL} { return [split [SequenceFormatEMBL $TFA "" "tfa"] "\n"] }
	return $TFA
    }

    set LaSequence {}
    
    Wup "It's a file"
    if {[regexp "/" $BanqueId]} {
	if {[file exists $BanqueId]} {
	    if {[file isdirectory $BanqueId]} {
		set AccessOK ""
		return [lsort [glob -nocomplain "$BanqueId/*"]]
	    }
	    set LaSequence [LesLignesDuFichier $BanqueId]
#	    Warne "fichier $BanqueId"
	    set AccessOK [file tail $BanqueId]
	    set NomDuFichier [file tail $BanqueId]
	    set GCG [join $LaSequence "\n"]
	    if {[regexp "^LOCUS" $GCG]} {
		if { ! [regexp {[^\n]* [0-9]+ aa } $GCG]} {
		    set AccessOK $Access
		    if {$OnExigeNature} { return [split $GCG "\n"] }
		    set FichierGB "[RepertoireDeTravail]/$NomDuFichier.gbtags"
		    Sauve $GCG dans $FichierGB
		    set LesLignesEMBL [split [FromInfoOfGenBankToEMBL [DecortiqueGBTags OS OC SeqADN $FichierGB] "nuc"] "\n"]
		    File delete -force $FichierGB
		    return $LesLignesEMBL
		} else {
		    set AccessOK $Access
		    if {$OnExigeNature} { return [split $GCG "\n"] }
		    set FichierGB "[RepertoireDeTravail]/$NomDuFichier.gbk"
		    Sauve $GCG dans $FichierGB
		    set LesLignesEMBL [split [FromInfoOfGenBankToEMBL [DecortiqueGenBank OS OC SeqProt $FichierGB] "prot"] "\n"]
		    File delete -force $FichierGB
		    return $LesLignesEMBL
		}
	    }
	    return [LaSequenceConvertieSiOnVeut $LaSequence $OnVeutEMBL $NomDuFichier]
	}
	if { $Previens } { FaireLire "$BanqueId not found in databases." }
	return {}
    }

    if {[EstUnPAB $BanqueId]} {
	if {[file exists "[RepertoireDuGenome]/protembl/$BanqueId"]} {
	    set AccessOK $BanqueId
	    set LesLignesEMBL [LesLignesDuFichier "[RepertoireDuGenome]/protembl/$BanqueId"]
	    return $LesLignesEMBL
	}
    }
    if {[EstUnPAB $Access]} {
	if {[file exists "[RepertoireDuGenome]/protembl/$Access"]} {
	    set AccessOK $Access
	    set LesLignesEMBL [LesLignesDuFichier "[RepertoireDuGenome]/protembl/$Access"]
	    return $LesLignesEMBL
	}
	if {[file exists "[RepertoireDuGenome]/nucembl/$Access"]} {
	    set AccessOK $Access
	    set LesLignesEMBL [LesLignesDuFichier "[RepertoireDuGenome]/nucembl/$Access"]
	    return $LesLignesEMBL
	}
    }

    if {[EstUnAccessPDB $BanqueId]} {
	set AccessOK $BanqueId
	if {$OnExigeNature} {
	    set LeNature [split [TextePDB $BanqueId] "\n"]
	    if {$LeNature!={}} { return $LeNature }
	}
	set LesLignesEMBL [split [EMBLduPDB $BanqueId] "\n"]
	return $LesLignesEMBL
    }

    if {[info exists QuidSeqEstDisponible] && $QuidSeqEstDisponible} {
	set EMBL [QuestionDeScience QuidSeq "QuidRefSeqOfAC $Access"]
	if {[regexp "^ID   " $EMBL]} {
	    set LesLignesEMBL [split $EMBL "\n"]
	    set AccessOK $Access
#	    Warne "QuidSeq $Access"
	    return $LesLignesEMBL
	}
    }

    if {[OutsideIGBMC]} {
	set LaReponse [WgetzSurWeb $BanqueId]
	if {$LaReponse!={} && ! [regexp -nocase "^ERREUR" $LaReponse]} { return $LaReponse }
	if {[SembleEtreUnAccessVarsplic $BanqueId]} {
	    return [LaSequenceDesBanques "VARSPLIC:$BanqueId"]
	}
	return {}
    }

    set EMBL [Getz $Access]
    if {[regexp "^ID   " $EMBL]} {
	set LesLignesEMBL [split $EMBL "\n"]
	set AccessOK $Access
#	Warne "getz $Access"
	return $LesLignesEMBL
    }

    if {[set Alternatif [AccessAlternatif $Access]]!=""} {
	set EMBL [Getz $Alternatif]
	if {[regexp "^ID   " $EMBL]} {
	    set LesLignesEMBL [split $EMBL "\n"]
	    set AccessOK $Access
#	    Warne "getz $Access alternatif $Alternatif"
	    return $LesLignesEMBL
	}
    }

    if {[SembleEtreUnAccessVarsplic $BanqueId]} {
	set LesLignesEMBL [LaSequenceDesBanques "VARSPLIC:$BanqueId"]
	if {$LesLignesEMBL!={}} { return $LesLignesEMBL }
    }

    set GB [Getz $Access "Genbank GenbankNew"]
    if {[regexp "\nACCESSION   " $GB]} {
	set AccessOK $Access
	if {$OnExigeNature} { return [split $GB "\n"] }
	set FichierGB "[RepertoireDeTravail]/$Access.genbank"
	Sauve $GB dans $FichierGB
	if {$OnExigeNuc} {
	    set LesLignesEMBL [split [FromInfoOfGenBankToEMBL [DecortiqueGBTags OS OC SeqADN $FichierGB] "nuc"] "\n"]
	} else {
	    set LesLignesEMBL [split [FromInfoOfGenBankToEMBL [DecortiqueGenBank OS OC SeqADN $FichierGB]] "\n"]
	}
	File delete -force $FichierGB
	return $LesLignesEMBL
    }
	
    set GB [Getz $Access "est sts gss htg htc"]
    if {[regexp "\nACCESSION   " $GB]} {
	set OnExigeNuc 1
	set AccessOK $Access
	if {$OnExigeNature} { return [split $GB "\n"] }
	set FichierGB "[RepertoireDeTravail]/$Access.gbtags"
	Sauve $GB dans $FichierGB
	if {$OnExigeNuc} {
	    set LesLignesEMBL [split [FromInfoOfGenBankToEMBL [DecortiqueGBTags OS OC SeqADN $FichierGB] "nuc"] "\n"]
	} else {
	    set LesLignesEMBL [split [FromInfoOfGenBankToEMBL [DecortiqueGenBank OS OC SeqADN $FichierGB]] "\n"]
	}
	File delete -force $FichierGB
	return $LesLignesEMBL
    }
	
    if {[info exists EviteSPTNEW] && $EviteSPTNEW && [regexp -nocase "^SPTNEW" $BanqueId]} {
	Warne "$BanqueId $Access not found. I don't search in SPTNEW with GCG"
	if { 0 && $Previens } { FaireLire "$BanqueId $Access not found.\
		I don't search in SPTNEW with GCG. I ignore it." }
	return {}
    }


    Wup "On ne l'a donc jamais vu  ... On essaye GCG."

    set TryGCG 1
    if {$TryGCG} {
	set AccessGCG $BanqueId
	set GCG [FetchCat $AccessGCG]
	if {$GCG == ""} {
	    set AccessGCG $Access
	    set GCG [FetchCat $AccessGCG]
	}
	if {$GCG != ""} {
	    set GCG [QueLePremierGCG $GCG]
	    if {[regexp "^!!NA_SEQUENCE" $GCG] && [regexp "\nACCESSION " $GCG]} {
		set AccessOK $Access
		if {$OnExigeNature} { return [split $GCG "\n"] }
		set FichierGB "[RepertoireDeTravail]/$Access.gbtags"
		Sauve $GCG dans $FichierGB
		set LesLignesEMBL [split [FromInfoOfGenBankToEMBL [DecortiqueGBTags OS OC SeqADN $FichierGB] "nuc"] "\n"]
		File delete -force $FichierGB
		return $LesLignesEMBL
	    }
	    if {[regexp "^!!AA_SEQUENCE" $GCG] && [regexp "\nACCESSION " $GCG]} {
		set AccessOK $Access
		if {$OnExigeNature} { return [split $GCG "\n"] }
		set FichierGB "[RepertoireDeTravail]/$Access.gbk"
		Sauve $GCG dans $FichierGB
		set LesLignesEMBL [split [FromInfoOfGenBankToEMBL [DecortiqueGenBank OS OC SeqProt $FichierGB] "prot"] "\n"]
		File delete -force $FichierGB
		return $LesLignesEMBL
	    }
	    set AccessOK $AccessGCG	
	    set LesLignesGCG [split $GCG "\n"]
	    if { $OnExigeNature} { return $LesLignesGCG }
	    if { ! $OnVeutEMBL } { return $LesLignesGCG }
	    set iSQ [lsearch -regexp $LesLignesGCG "^SQ"]
	    set Entete [lrange $LesLignesGCG 0 $iSQ]
	    set Suite  [lrange $LesLignesGCG $iSQ end]
	    set iPP  [lsearch -regexp $Suite {\.\.}]
	    set iFin [lsearch -regexp $Suite "^ID"]
	    if {[incr iFin -1] < 0} { set iFin "end" }
	    set Sequence [join [lrange $Suite [incr iPP] $iFin] ""]
	    regsub -all {[ 0-9]} $Sequence "" Sequence
	    set LaSeqEMBL [split [QueSequenceFormatEMBL $Sequence "SansSQ"] "\n"]
	    set LesLignesEMBL [concat $Entete $LaSeqEMBL "\n//"]
	    return $LesLignesEMBL
	}
    }
    Warne "$BanqueId $Access not found."
    if { $Previens } { FaireLire "$BanqueId introuvable. Je l'ignore." }
    return {}
}

proc AfficheFetch {Selection {NomDuFichierOrigine ""}} {

    #global RepertoireDuGenome
    global AccessDejaVus

    
    Wup "On cherche la sequence et on l'affiche"
    
    Gs "Frame"

    if {[regexp " " $NomDuFichierOrigine]} {
	foreach Mot [split $NomDuFichierOrigine " "] {
	    if {[regexp "/" $Mot]} { set NomDuFichierOrigine $Mot ; break }
	}
    }
    if {[regexp " " $NomDuFichierOrigine]} { scan $NomDuFichierOrigine "%s" NomDuFichierOrigine }
	
    
    set FormatVoulu ""
    if {$NomDuFichierOrigine=="OnVeutNature"} {
	set FormatVoulu "OnVeutNature"
	set NomDuFichierOrigine ""
    }
    if {[regexp "^OnVeut" $NomDuFichierOrigine]} {
	set FormatVoulu $NomDuFichierOrigine
	set NomDuFichierOrigine ""
    }

    Espionne "$NomDuFichierOrigine $FormatVoulu"

    set Nom ""
    if {$NomDuFichierOrigine != "" } {
	set Nom [file tail $NomDuFichierOrigine]
	Wup "NomDuFichierOrigine peut finir par Nom (de PAB)"
	if { ! [YaPABdans $Nom]} {
	    Wup "Recherche du pab si c'est un copain"
	    set Nom [file tail [file dirname $NomDuFichierOrigine]]
	}
	if { ! [YaPABdans $Nom]} { set Nom "" }
    }
    Wup "Si Nom n'est pas vide c'est qu'on a affaire a un PAB"
    
    set LesFramesFetchees {}
    
    set Liste [split $Selection "\n"]
    foreach Ligne $Liste {
	if { ! [regexp -nocase {[a-z0-9_]} $Ligne]} { continue }
	set Ligne [OteSuperfluPourFetch $Ligne]
	scan $Ligne "%s" aPDB
	if {[EstUnAccessPDB $aPDB]} {
	    if {[info exists DejaVu($aPDB)]} { continue }
	    set  DejaVu($aPDB) 1
	    if {[set LaFramePDB [AffichePDB $aPDB]]!=""} { 
		lappend LesFramesFetchees $LaFramePDB
		continue
	    } 
	}

	set BanqueId ""
	set Access ""

	Wup "On cherche d'abord Access dans la ligne"
	if { [regexp "^Query=" $Ligne] } {
	    Wup "C'est une ligne Query"
	    set Access [QueryDeLaLigne $Ligne]
	} elseif  { [regexp "^Name:" $Ligne] } {
	    Wup "C'est une ligne d'un MSF"
	    set Access [lindex [split $Ligne " "] 1]
	} elseif  { [regexp {^(AC|ID) } $Ligne] } {
	    Wup "C'est une ligne d'un EMBL"
	    scan $Ligne "%s %s" AC Access
	} elseif {[regexp {^[a-zA-Z0-9_]+:[a-zA-Z0-9_]+[ !]* [a-zA-Z0-9_]+} $Ligne]} {
	    Wup "Ligne blast"
	    regsub "!" $Ligne " " BanqueId_Access
	    scan $BanqueId_Access "%s %s" BanqueId Access
	} elseif { [regexp {^[a-zA-Z0-9_]+: +[a-zA-Z0-9_]+} $Ligne]} {
	    Wup "Ligne du type 'Clef: access'"
	    scan $Ligne "%s %s" Bidon Access
	} else {
	    scan $Ligne "%s" Access
	}
	if {$BanqueId==""} { set BanqueId $Access }
	Espionne "BanqueId Access $BanqueId $Access"

	if {[info exists DejaVu($BanqueId,$Access)]} { continue }
	set AccessOk ""
	set Sequence [join [LaSequenceDesBanques $BanqueId $Access AccessOk $FormatVoulu] "\n"]
	if {$Sequence!=""} {
	    set  DejaVu($BanqueId,$Access) 1
	    lappend LesFramesFetchees [AfficheVariable $Sequence "AvecBlasteAvecFormate" $AccessOk]
	    continue
	}
	Wup "Ici on n'a toujours rien trouve ... "
	set FichierMSF "[RepertoireDuGenome]/msf/$Nom"
	if {[info exists DejaVu($FichierMSF)]} { continue }
	if {[YaPABdans $Nom] && [file exists $FichierMSF]} {
	    set Sequence [UneSequenceDuMSF $FichierMSF $Access]
	    set TFA [SequenceFormatTFA $Sequence $Access "protbrut"]
	    if {$TFA!=""} { 
		set  DejaVu($FichierMSF) 1
		lappend LesFramesFetchees [AfficheVariable $TFA "AvecBlasteAvecFormate"]
		continue
	    }
	}
    }
    
    if {[llength $LesFramesFetchees]>0} {
	return [lindex $LesFramesFetchees 0]
    }
}

proc AfficheLesAliEnPage {Page Selection Fichier} {
    foreach s [split $Selection "\n"] {
	AfficheAliEnPage $Page $s $Fichier
    }
}

proc AfficheAliEnPage {Page LigneAccess Fichier} {

    return [AfficheVariable [PartieSegAli $Page $LigneAccess] " " $Fichier]
}

proc PartieSegAli {Page LigneAccess} {
    scan $LigneAccess "%s" Access
    regsub {\.+$} $Access "" Access
    set Cherche ">$Access "
    set Debut [string first $Cherche $Page]
    while {$Debut<0} {
	if {[OuiOuNon "I cannot find the segment alignment for $Cherche\nDo I stop searching ?"]} { return "" }
	set Cherche [string range $Cherche 0 end-1]
	set Debut [string first $Cherche $Page]
    }
    set Fin   [string first "\n>" [string range $Page [expr $Debut+1] end]]
    if { $Fin < 0 } {
	set Fin "end"
    } else {
	incr Fin [expr $Debut+1]
    }
    return [string range $Page $Debut $Fin]
}

proc EstUnPAB Texte {
    return [regexp "^[ExpressionReguliereDesPABs]$" $Texte]
}

proc ExpressionReguliereDesPABs {} {
    global ConfigChargee
    if { ! [info exists ConfigChargee] || ! $ConfigChargee } { return "EXPRESSION_REGULIERE_DES_PABS_NON_VALIDE" }
    return "^[PreFixe]\[0-9\]+"
}

proc PreFixe {{Nouveau ""}} {
    global PrefixeDesORFs

    if {$Nouveau!=""} { set PrefixeDesORFs $Nouveau }

    if { ! [info exists PrefixeDesORFs]} { set PrefixeDesORFs "ORF" }
    return $PrefixeDesORFs
}

proc Gonfle {w Tag {ScaleX "gonfle"} {ScaleY 1.0}} {
    global ScaleCumuleDeGonfle OrigXCumuleDeGonfle OrigYCumuleDeGonfle
    global ScrollRectangleOriginal IdScrollRectangle
    
    set K       $w.canvas
    set ScroHor $w.hscroll
    set ScroVer $w.vscroll

    scan "[$ScroHor get]" "%f %f" g d
    scan "[$ScroVer get]" "%f %f" b h

    set RatioHor [expr ($g + $d)/2]
    set RatioVer [expr ($b + $h)/2]

    scan [$K cget -scrollregion] "%f %f %f %f" xMin yMin xMax yMax
    set CentreHor [expr $xMin + $RatioHor*($xMax-$xMin)]
    set CentreVer [expr $yMin + $RatioVer*($yMax-$yMin)]

    if {[regexp "expo" $K]} {
	set CentreHor 0
	set CentreVer 0
    }

    set ScaleGonfle 1.1

    if { $ScaleY == "gonfle" }   {
	set Scaley $ScaleGonfle
    }
    if { $ScaleY == "degonfle" } {
	set Scaley [expr 1./$ScaleGonfle]
    }
    if { $ScaleX == "gonfle" }   {
	set Scalex $ScaleGonfle
	set Scaley 1.0
    } else {
	set Scalex $ScaleX
	set Scaley 1.0
    }
    if { $ScaleX == "degonfle" } {
	set Scalex [expr 1./$ScaleGonfle]
	set Scaley 1.0
    }
    if { $ScaleY != "1.0"} {
	set Scaley $ScaleY
    }
    if { $ScaleY == "gonfle" }   {
	set Scaley $ScaleGonfle
    }
    if { $ScaleY == "degonfle" } {
	set Scaley [expr 1./$ScaleGonfle]
    }

    if { $ScaleX == "reset" } {
	scan [$K coords [set IdScrollRectangle($K)]] "%f %f %f %f" xMin  yMin  xMax  yMax
	scan [set ScrollRectangleOriginal($K)]       "%f %f %f %f" xMinO yMinO xMaxO yMaxO
	set Scalex [expr ($xMaxO-$xMinO)*1.0/($xMax-$xMin)]
	set Scaley [expr ($yMaxO-$yMinO)*1.0/($yMax-$yMin)]
    }

    $K scale $Tag $CentreHor $CentreVer $Scalex $Scaley
    $K configure -scrollregion [$K coords [set IdScrollRectangle($K)]]

    return $K
}

proc ButineArborescence {{Type "All"} {RepertoireEtFichier ""}} {

    global RepertoireInitialDeButine
    global FichierInitialDeButine

    if {[regexp {/$} $RepertoireEtFichier]} {
	regsub {/$} $RepertoireEtFichier "" Rep
	set Fic ""
    } else {
	set Rep [file dirname $RepertoireEtFichier]
	set Fic [file tail $RepertoireEtFichier]
    }
    if {$Rep!=""} {
	set RepertoireInitialDeButine $Rep
    }
    if {$Fic!=""} {
	set FichierInitialDeButine $Fic
    }

    if { ! [info exists RepertoireInitialDeButine]} { set RepertoireInitialDeButine [pwd] } 
    if { ! [info exists FichierInitialDeButine]}    { set FichierInitialDeButine "" } 


    set Types(All) {
	{{All files}            *  }
    }
    
    set Types(MSF) {
	{{Alignment output}  {.msf}}
	{{All files}            *  }
    }
    
    set Types(Blastp) {
	{{Blast output}   {.blastp}}
	{{All files}            *  }
    }
    
    set Types(FOF) {
	{{File Of Filenames} {.fof}}
	{{All files}            *  }
    }
    
    set Types(ps) {
	{{Postcript file} {.ps}}
	{{All files}            *  }
    }
    
    set Types(Sequence) {
	{{All files}            *  }
	{{Raw}               {.seq}}
	{{Fasta}             {.tfa}}
	{{GCG}               {.ged}}
    }

    set NomDeFichier [tk_getOpenFile -title "Open file" \
	    -initialdir $RepertoireInitialDeButine \
	    -initialfile $FichierInitialDeButine \
	    -defaultextension "" \
	    -filetypes $Types($Type)]
    if { $NomDeFichier == "" } { return ""}
    set RepertoireInitialDeButine [file dirname $NomDeFichier]    
    return $NomDeFichier
}

proc Blaste {Programme Sequence {NomOuNumOuSortie ""} {Banque ""}} {

    global RepertoireDuGenome
    global Commandes

    if {[FormatDeLaSequence $Sequence] == "tfas"} {
	foreach Seq [split [string range $Sequence 1 end] ">"] {
	    Blaste $Programme ">$Seq"
	}
	return 
    }

    if {[regexp "/" $NomOuNumOuSortie]} {
	set NomNum "[RepertoireDeTravail]/tmp.[pid][NomDe ""]"
	set Sortie $NomOuNumOuSortie
    } else {
	set Sortie ""
	if { $NomOuNumOuSortie == "" } {
	    set NomNum "[RepertoireDeTravail]/tmp.[pid][NomDe ""]"
	} elseif { [regexp {^[a-zA-Z]} $NomOuNumOuSortie ] } {
	    set NomNum ${NomOuNumOuSortie}[NomDe ""]
	} elseif { [regexp {^[0-9]} $NomOuNumOuSortie ] } {
	    set NomNum "[RepertoireDeTravail]/tmp.$NomOuNumOuSortie"
	} else {
	    set NomNum "[RepertoireDeTravail]/tmp.[pid][NomDe ""]"
	    set Sortie $NomOuNumOuSortie
	}
    }
    set Tmp $NomNum

    #set In  "$Tmp"
    #set Out "$In.blastp"
    set In  "[file join $Tmp]"
    set Out "[file join $In.blastp]"
    set Log "$Out.log"

    Sauve [SequenceFormatTFA $Sequence] dans $In

    if {$Sortie==""} { set AskOrNot "" } else { set AskOrNot "DontAsk" }
    
    if { $Programme == "P"     } {
	if {$Banque==""} { set Banque "[file join [BLASTDBDIR] protall]" }
	set Prog "blastp"
    } elseif { $Programme == "X"    } {
	if {$Banque==""} { set Banque "[file join [BLASTDBDIR] protein]" }
	set Prog "blastx"
    } elseif { $Programme == "tN"    } {
	if {$Banque==""} { set Banque "[file join [BLASTDBDIR] genomes]" }
	set Prog "tblastn"
    } elseif { $Programme == "Choix" } {
	set Prog ""
    } else {
	set Prog [ChoixParmi "blastp" "tblastn" "blastx" "blastn"] 
    }
    set Commande [ChoisisTonBlast $In $Out $Prog $Banque $AskOrNot]

    if {$Commande==""} { return "" }
    if {$Sortie!=""} {
	regsub {^.*batchcom.tcl *} $Commande "" Commande
	set Etat [eval $Commande]
	if { ! [file exists $Out]} { return "" }
	if {$Sortie=="retourne"} { return [ContenuDuFichier $Out] }
	file copy -force $Out $Sortie
	return $Sortie
    }

    #AjouteAuLog "$Commande"
    set Message ""  
    if {[catch {eval set Canal [open "| $Commande" r]} Message]} {
    	AjouteAuLog "Message: $Message"
	#Warne $Message
    }
    #AjouteAuLog "Canal: $Canal"

    fconfigure $Canal -blocking false -buffering line
    fileevent  $Canal readable "ClosCanalEtMontreBlaste $Canal $Out"
    #Warne "Blast $Programme lance en batch"
}

proc ChoisisTonBlast {FichierTFA FichierBlast {Programme ""} {Banque ""} {Ask ""}} {
    global RepertoireDuGenome
    global GscopeDir

    if {$Ask=="DontAsk"} { set Ask 0 } else { set Ask 1 }

    if {$Programme==""} {
	set Programme [ChoixParmi {blastp blastx blastn tblastn tblastx Other}]
	if {$Programme == "Other"} { set Programme [Entre] }
	if {$Programme == ""} { return "" }
    }
    set AvecBanques "nucpro"
    if {[regexp {^blastp$|^blastx$} $Programme]} {
	regsub "nuc" $AvecBanques "" AvecBanques
    }
    if {[regexp {^tblastn$|^tblastx$|^blastn$} $Programme]} {
	regsub "pro" $AvecBanques "" AvecBanques
    }
    
    if {$Banque==""} {
	lappend LesRepertoiresDesBanques "[file join $RepertoireDuGenome banques]"
	lappend LesRepertoiresDesBanques "[file join $RepertoireDuGenome banquesblast]"
	if {[BLASTDBDIR] != ""} {
	    lappend LesRepertoiresDesBanques "[BLASTDBDIR]"
	}
	set LesBanques {}
	foreach RepBan $LesRepertoiresDesBanques {
	    if {[regexp "nuc" $AvecBanques]} {
		set LesBanques [concat $LesBanques [glob -nocomplain -directory $RepBan "*.nsq"]]
		set LesBanques [concat $LesBanques [glob -nocomplain -directory $RepBan "*.nal"]]
	    }
	    if {[regexp "pro" $AvecBanques]} {
		set LesBanques [concat $LesBanques [glob -nocomplain -directory $RepBan "*.psq"]]
		set LesBanques [concat $LesBanques [glob -nocomplain -directory $RepBan "*.pal"]]
	    }
	}

	set LesBonnesBanques {}
	foreach Banque [lsort $LesBanques] {
	    regsub {\.nsq$|\.psq$|\.nal$|\.pal$} $Banque "" Banque
	    if {[info exists DejaVu($Banque)]} {continue}
	    set DejaVu($Banque) 1
	    lappend LesBonnesBanques $Banque
	}
	lappend LesBonnesBanques "Other"
	set Banque [ChoixParmi $LesBonnesBanques]
	if {$Banque == "Other"} {
	    set Banque [ButineArborescence "All" [RepertoireDuGenome]]
	    regsub {\.[np]..$} $Banque "" Banque
	}
	if {$Banque == ""} { return "" }
    }

    #CADO4MI modif
    set BatchCom "[file join "$GscopeDir" "CADO4MI_batchcom.tcl"]"
    #set CommandeBlast "C:/Tcl/bin/tclsh.exe $BatchCom eval exec [CADO4MI_PATH blastall]"
    #set CommandeBlast "tclsh $BatchCom eval exec [CADO4MI_PATH blastall]"
    set CommandeBlast "tclsh $BatchCom eval exec [CADO4MI_PATH blastall] \
	    -p $Programme \
	    -i $FichierTFA \
	    -o $FichierBlast \
	    -d $Banque \
	    -v 500 \
	    -K 0 \
	    -b 500 \
	    -e 10.0 \
	    -F T \
	    -a 4"

    if {$Ask} {
	set CommandeBlast [Entre $CommandeBlast]
    }
    return $CommandeBlast
}

proc ClosCanalEtMontreBlaste {Canal Out} {

    set Ligne1 0    
    set Ligne2 0

    set i 0
    while {[gets $Canal line] >= 0} {
	incr i
	set Ligne${i} $line
	#Espionne "$i : $line"
    }

    if {$Ligne1} {
        close $Canal
        set Fenetre [AfficheFichier $Out "AvecGrapheAvecSegAlignementAvecAligneurs"]
        return 1
    }
    close $Canal
    set Message $Ligne2
    set Texte "I got an error from batch blast with following message :\n$Message"
    set Fenetre [AfficheVariable $Texte "ErrorFromBlast"]
    return 0
}
